#!/usr/bin/perl

##########################################################################
$main_dir = ".";                 #sppds 丮  
$main_url = ".";				 #sppds 丮 ִ° URL	
$cgi_url = "./pds.cgi";			 #pds.cgi URL
$img_url = "./img";              #img丮  URL
$sendmail = "/usr/lib/sendmail"; #sendmail ġ
##########################################################################

&parseArgument;

sub parseArgument {
    local($pair,$name,$value,$content_type,$content_length,$buffer,$dump,$boundary,$line,$array_value);
    local(@pairs,@column);

    if($ENV{'QUERY_STRING'}) {
    @pairs = split(/&/,$ENV{'QUERY_STRING'});

        foreach $pair (@pairs) {
            ($name, $value) = split(/=/,$pair);

            $value =~ tr/+/ /;
            $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;

            $FORM{$name} = $value;
        } 
    }
    else {
        $content_type = $ENV{'CONTENT_TYPE'};
        $content_length = $ENV{'CONTENT_LENGTH'};

        binmode STDIN;
        read(STDIN,$buffer,$content_length);
 
        if((!$content_type) ||
           ($content_type eq 'application/x-www-form-urlencoded')) {
            @pairs = split(/&/, $buffer);

            foreach $pair (@pairs)  {
                ($name, $value) = split(/=/,$pair);
                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 
                $FORM{$name} = $value;
            }
        }
        elsif($content_type =~ m#^multipart/form-data#) {
            ($boundary = $content_type) =~ s/^.*boundary=(.*)$/\1/;
            @pairs = split(/--$boundary/, $buffer);
            @pairs = splice(@pairs,1,$#pairs-1);

            for $pair (@pairs)  {
                ($dump,$line,$value) = split(/\r\n/,$pair,3);
                if($line =~ /filename/) {
	            $real_file = $line;
                }

                next if $line =~ /filename=\"\"/;
                $line =~ s/^Content-Disposition: form-data; //;
                (@column) = split(/;\s+/, $line);
                ($name = $column[0]) =~ s/^name="([^"]+)"$/\1/g;
 
                if($#column > 0) { 
                    if($value =~ /^Content-Type:/)  {
                        ($dump,$dump,$value) = split(/\r\n/,$value,3);
                    }
                    else {
                        ($dump,$value) = split(/\r\n/,$value,2);
                    }
                }
                else {
                    ($dump,$value) = split(/\r\n/,$value,2);
                    if(grep(/^$name$/, keys(%CGI))) {
                        if(@{$FORM{$name}} > 0) {
                            push(@{$FORM{$name}}, $value);
                        }
                        else { 
                            $array_value = $FORM{$name};
                            undef $FORM{$name};
                            $FORM{$name}[0] = $array_value;
                            push(@{$FORM{$name}}, $value);
                        }
                    }
                    else {
                        next if $value =~ /^\s*$/;
                        $FORM{$name} = $value;
                        chop($FORM{$name});
	                chop($FORM{$name});
                    }
                    next;
                }
                $FORM{$name} = $value;
            }
        }
        else {
            print "Invalid content type!\n";
            exit(1);
        }
    }

	$main_dir = "$main_dir/$FORM{'id'}";
	$main_url = "$main_url/$FORM{'id'}";
	&selectAction;
}

sub selectAction {

	if($FORM{'page'} eq ""){
		$page = 1; 
	}
	else {
		$page= $FORM{'page'};
	}

	if($FORM{'id'}) {
		&get_env;
		
		if($FORM{'action'} eq "") {
			&display;
		}
		elsif($FORM{'action'} eq "form") {
			&input_form;
		}
		elsif($FORM{'action'} eq "write") {
			if(($FORM{'name'} eq "") || ($FORM{'comments'} eq "")||($FORM{'subject'} eq "")){
				&error;
			}
			else {	&write;	}
		}
		elsif($FORM{'action'} eq "adminwrite") {
			&adminwrite;
		}
		elsif($FORM{'action'} eq "view") {
			&view;
		}
		elsif($FORM{'action'} eq "down") {
			&down_file;
		}
		elsif($FORM{'action'} eq "reply") {
			&reply_form;
		}
		elsif($FORM{'action'} eq "admin_login") {
			&admin_login;
		}
		elsif($FORM{'action'} eq "loginok") {
			$pass = crypt($FORM{'passwd'},sp);
			if(($pass eq "") || ($pass ne $admin)) {
				$err = pass;
				&error;
			}
			&loginok;
		}
		elsif($FORM{'action'} eq "view_notice"){
			&view_notice;
		}
		elsif($FORM{'action'} eq "modify"){
			&enterpass;
		}
		elsif($FORM{'action'} eq "admin_modify"){
			&admin_ok;
		} 
		elsif($FORM{'action'} eq "admin_remove"){
			&admin_remove;
		}
		elsif($FORM{'action'} eq "admin_act"){
			if($FORM{'admin_select'} eq "admin_conf"){ 
				&admin_conf;
			}
			elsif($FORM{'admin_select'} eq "notice_form"){
				&notice_form;
			}
		}
		elsif($FORM{'action'} eq "admin_remove_ok"){
			$pass = crypt($FORM{'passwd'},sp);
			if(($admin ne $pass)||($pass eq "")) {
				$err = pass;
				&error;
			}
			elsif($admin eq $pass) {
				&admin_remove_ok;
			}
		}
		elsif($FORM{'action'} eq "passok"){
			&passok;
		}
		elsif($FORM{'action'} eq "modify_ok") {
			if(($FORM{'name'} eq "") || ($FORM{'comments'} eq "")|| ($FORM{'subject'} eq "")) {
				&error;
			}
			else { &modify;}
		}
		elsif($FORM{'action'} eq "admin_ok"){
			$pass = crypt($FORM{'passwd'},sp);
			if(($admin ne $pass)||($pass eq "")) {
				$err = pass;
				&error;
			}
			elsif($admin eq $pass){
				&admin_modify_form;
			}
		}
		elsif($FORM{'action'} eq "make_conf"){
			&make_conf;
		}
		elsif($FORM{'action'} eq "erase") {
			&erase;
		}
		elsif($FORM{'action'} eq "search") { 
			if($FORM{'keyword'} eq ""){
				$err = keyword;
				&error;
			}
			else{
				&search;
			}
		}
		elsif($FORM{'action'} eq "eraseok") {
			if($FORM{'passwd'} eq "") {
				$err = pass;
				&error;
			}
			&eraseok;
		}
		else {
			&display;
		}
	}
	else{ 
		$err = id;
		&error;
	}
}

sub get_env{
	unless(-e "$main_dir/data.txt"){
        mkdir("$main_dir/files",0777);
		open(DATA, ">$main_dir/data.txt");
		print DATA "0\n";
		close(DATA);
		open(MAIN, ">$main_dir/main.txt");
		print MAIN "0\n";
		close(MAIN);
	}

    if(open(CONF,"<$main_dir/conf.txt")) {
        @list = <CONF>;
        close(CONF);
        @env = split(/\|/,$list[0]);
		
		$max_size = $env[0];
        $page_num = $env[1];
		$admin_only = $env[2];
        $max_data = $env[3];
        $admin = $env[4];
        $smail = $env[5];
        $admin_mail = $env[6];
		$home_url = $env[7];
        $width = $env[8];
        $admin_name = $env[9];
        $ncel_color = $env[10];
        $head_color = $env[11];
		$cel_color = $env[12];
		$select_color = $env[13];
        $num_color = $env[14];
        $date_color = $env[15];
        $read_color = $env[16];
		$bgcolor = $env[17];
		$background = $env[18];
		$logo_img = $env[19];
		$logo_txt = $env[20];
		$search_view = $env[21];
	}
    else {
		$max_size = "4.5";
        $page_num = "10";
		$admin_only = "no";
        $max_data = "5000";
        $admin = "1234";
        $smail = "yes";
        $admin_mail = "your\@email.net";
		$home_url = "http://yourhome.net";
        $width = "80%";
        $admin_name = "";
        $ncel_color = "#FFFDD8";
        $head_color = "#000000";
		$cel_color = "#F4F4F4";
		$select_color= "#D5D5D5";
        $num_color = "#1504B9";
        $date_color = "#FF6666";
        $read_color = "#0A5818";
		$bgcolor = "#ffffff";
		$background = "";
		$logo_img = "";
		$logo_txt = "Ȱ¦~  ڷ ^.^";
		$search_view = "yes";
		&save_env;
	}
}

sub save_env { 
	$admin = crypt($admin,sp);
	open(CONF,">$main_dir/conf.txt");
        print CONF "$max_size|$page_num|$admin_only|$max_data|$admin|$smail|$admin_mail|$home_url|$width|$admin_name|$ncel_color|$head_color|$cel_color|$select_color|$num_color|$date_color|$read_color|$bgcolor|$background|$logo_img|$logo_txt|$search_view|\n";
    close(CONF);
}

sub display {
	open(Num,"<$main_dir/data.txt");
	$num = <Num>;
	close(Num); 
  
	opendir (DATA,"$main_dir");
	@num_data = readdir(DATA);
	$fil_data = @num_data-6;
	closedir(DATA);

	open(WF,"$main_dir/main.txt");
	$cou = <WF>;
	close(WF);

	$file_num = $num;
	$tot_pg = int($cou/$page_num);
	if(($tot_pg*$page_num) < $cou) { $tot_pg = $tot_pg + 1; }
    if(!$new) {&head;}
	if(($FORM{'page'} eq "") || ($FORM{'page'} eq "1")) {
		$FORM{'page'} = "1";
		$d = 0;
		$s = 0;
		if(!$new) {
			print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
			if($tot_pg <= 1) {
				print "<table width=$width cellspacing=0 cellpadding=2 border=0><tr><td width=160 align=left>|<b><a href=$cgi_url?id=$FORM{'id'}&action=form><font color=blue><font color=$head_color>ڷ ø</font></font></a></b>|</td><td align=center><font face=arial size=1>Total <font color=red>$fil_data</font>articles [ <font color=green>$page</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right>|||</td></tr></table>\n";
			}
			else {
				print "<table width=$width cellspacing=0 cellpadding=2 border=0><tr><td width=160 align=left>|<b><a href=$cgi_url?id=$FORM{'id'}&action=form><font color=blue><font color=$head_color>ڷ ø</font></font></a></b>|</td><td align=center><font face=arial size=1>Total <font color=red>$fil_data</font>articles [ <font color=green>$FORM{'page'}</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right>||<a href=$cgi_url?id=$FORM{'id'}&page=2></a>|</td></tr></table>\n";
			}
			print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		}
		print "<table width=$width border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td width=13 align=left><font color=$cel_color></font></td><td  align=center><font size=-1 color=$cel_color face=arial>  </font></td><td align=center><font size=-1 color=$cel_color face=arial> &nbsp; </font></td><td width=100 align=center><font size=-1 color=$cel_color face=arial>ۼϽ</font></td><td width=30 align=center><font size=-1 color=$cel_color face=arial>Down</font></td></tr>\n";
		
		if((-e "$main_dir/notice.txt") && ($FORM{'action'} ne "view")){
			open(FILE, "<$main_dir/notice.txt");
			@gul = <FILE>;
			@notice = split(/\|/,$gul[0]);
			close (FILE);
			$subject = $notice[1];
			$comment = $notice[2];
			$wdate = substr($notice[3],5,13);
			@die_date = split(/:/, $notice[4]);
			$die_year = $die_date[0];
			$die_mon = $die_date[1];
			$die_day = $die_date[2];
			$read_num = $notice[5];
			&getdate;
			if($die_year eq $year){
				if($die_day  < $mday){
					if($die_mon le $month){
						unlink ("$main_dir/notice.txt") ;
					}
					else{
						print "<tr bgcolor=$ncel_color><td colspan=2> <img src=$img_url/notice.gif> <a href=$cgi_url?id=$FORM{'id'}&action=view_notice><b>$subject</b></a></td><td align=center>$admin_name</td><td align=center><font color=$date_color>$wdate</font></td><td align=center><font color=$read_color>$read_num</font></td></tr>\n";
					}
				}
				else{
					if($die_mon < $month){
						unlink ("$main_dir/notice.txt") ;
					}
					else{
						print "<tr bgcolor=$ncel_color><td colspan=2> <img src=$img_url/notice.gif> <a href=$cgi_url?id=$FORM{'id'}&action=view_notice><b>$subject</b></a></td><td align=center>$admin_name</td><td align=center><font color=$date_color>$wdate</font></td><td align=center><font color=$read_color>$read_num</font></td></tr>\n";
					}
				}
			}
			elsif($die_year > $year){
				print "<tr bgcolor=$ncel_color><td colspan=2> <img src=$img_url/notice.gif> <a href=$cgi_url?id=$FORM{'id'}&action=view_notice><b>$subject</b></a></td><td align=center>$admin_name</td><td align=center><font color=$date_color>$wdate</font></td><td align=center><font color=$read_color>$read_num</font></td></tr>\n";
			}
			else{
				unlink ("$main_dir/notice.txt") ;
			}
		}	

		$num = $num+1;
		until ($num<=0) {
			$num = ($num - 1);
			if(-e "$main_dir/$num") {
				open(FILE,"<$main_dir/$num");
				@data = <FILE>;
		        close (FILE);
				$d = ($d+1);
				$s++;
				@list = split(/\|/, $data[1]);
				if($list[1]) { 
					$mailto = "<a href=mailto:$list[1]>$list[0]</a>";
				}
				else {
					$mailto = $list[0];
				}           
				$old_date = substr($list[4],0,10);
				$rdate=substr($list[4],5,13);
				&getdate;
				$new_date = substr($date,0,10);
				if($old_date eq $new_date) {
					$subject = "<img src=$img_url/newgul.gif border=0>";
				}
				else{ 
					$subject = "<img src=$img_url/gul.gif border=0>";
				}
				if($FORM{'number'} eq $num){
					print "<tr bgcolor=$select_color><td align=left colspan=2><font color=$num_color face=arial size=-1>$d</font><img src=$img_url/zero.gif width=12 height=14><font face=arial size=-1>$subject $list[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$list[5]</font></td></tr>\n";
				}
				else{
					print "<tr bgcolor=$cel_color><td align=left colspan=2><font color=$num_color face=arial size=-1>$d</font><img src=$img_url/zero.gif width=12 height=14><font face=arial size=-1><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num>$subject $list[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$list[5]</font></td></tr>\n";
				}
				if ($data[3] > 0) {            
					&disps;    
				}
			}
			
			if($d >= $page_num) { $page=1; last}
		}	
	}
	if(($FORM{'page'} ne "") &&($FORM{'page'} !=1)) {
		$scount = (($FORM{'page'}-1)*$page_num);
		$icount = 0;
		$d = 0; 
		$pre_pg= $FORM{'page'} - 1;
		$next_pg = $FORM{'page'} + 1;
		if(!$new) {
			print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
			if($next_pg <= $tot_pg) {
				print "<table width=$width><tr><td width=160 align=left>|<a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=form><b><font color=blue><font color=$head_color>ڷ ø</font></font></b></a>|</td><td align=center><font face=arial size=1>Total <font color=red>$fil_data</font>articles [ <font color=green>$FORM{'page'}</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right>|<a href=$cgi_url?id=$FORM{'id'}&page=$pre_pg></a>|<a href=$cgi_url?id=$FORM{'id'}&page=$next_pg></a>|</td></tr></table>\n";
			}
			else {
				print "<table width=$width><tr><td width=160 align=left>|<a href=$cgi_url?id=$FORM{'id'}&action=form><b><font color=blue><font color=$head_color>ڷ ø</font></font></b></a>|</td><td align=center><font face=arial size=1>Total <font color=red>$fil_data</font>articles [ <font color=green>$FORM{'page'}</font>/<font color=blue>$tot_pg</font> page ]</font></td><td width=160 align=right>|<a href=$cgi_url?id=$FORM{'id'}&page=$pre_pg></a>||</td></tr></table>\n";
			}
			print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		}
		print "<table width=$width  border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td width=13 align=left><font color=$cel_color></font></td><td  align=center><font face=arial size=-1 color=$cel_color>  </font></td><td align=center><font face=arial size=-1 color=$cel_color> &nbsp; </font></td><td width=100 align=center><font face=arial size=-1 color=$cel_color>ۼϽ</font></td><td width=30 align=center><font face=arial size=-1 color=$cel_color>Down</font></td></tr>\n";
		
		until ($num<=0) {
			if(-e "$main_dir/$num") {
				$icount = $icount + 1;
				if($icount >= $scount) {
					open(FILE,"<$main_dir/$num");
					@data = <FILE>;
					close (FILE);
					$d = ($d+1);
					$s=$scount+$d;
					@list = split(/\|/, $data[1]);
					if($list[1]) { 
						$mailto = "<a href=mailto:$list[1]>$list[0]</a>";}else {$mailto = $list[0];
					}
					$old_date = substr($list[4],0,10);
					$rdate=substr($list[4],5,13);
					&getdate;
					$new_date = substr($date,0,10);
					if($old_date eq $new_date) {
						$subject = "<img src=$img_url/newgul.gif border=0>";
					} 
					else{
						$subject = "<img src=$img_url/gul.gif border=0>";
					}    
					if($FORM{'number'} eq $num){
						print "<tr bgcolor=$select_color><td align=left colspan=2><font color=$num_color face=arial size=-1>$s</font><img src=$img_url/zero.gif width=12 height=14><font face=arial size=-1>$subject $list[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$list[5]</font></td></tr>\n";
					}
					else{
						print "<tr bgcolor=$cel_color><td align=left colspan=2><font color=$num_color face=arial size=-1>$s</font><img src=$img_url/zero.gif width=12 height=14><font face=arial size=-1><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num>$subject $list[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$list[5]</font></td></tr>\n";
					}
					if ($data[3] > 0) {				
						&disps;
					}	
				}
				if($d >= $page_num) { 
					$page= $FORM{'page'}; 
					last
				}
			}
			$num = ($num - 1);
		}
	}
	print "</table><br>\n";
	
	&pagemove;
	
	if($search_view eq "yes"){
		&find;
	}

	&foot;
}

sub disps {
	for($z=1;$z<=$data[3];$z++) {
		if(-e "$main_dir/$num-$z") {
			open(FILE,"<$main_dir/$num-$z");
            @datas = <FILE>;
            close (FILE);
			@lists = split(/\|/, $datas[1]);
			if($lists[1]) { 
				$mailto = "<a href=mailto:$lists[1]>$lists[0]</a>";}else {$mailto = $lists[0];
			} 
			$old_date = substr($lists[4],0,10);
			$rdate=substr($lists[4],5,13);
			&getdate;
			$new_date = substr($date,0,10);
			if($old_date eq $new_date) {
				$subject = "<img src=$img_url/newans.gif border=0>";
			}
			else{ 
				$subject = "<img src=$img_url/ans.gif border=0>";
			} 
			if($FORM{'number'} eq "$num-$z"){
				print "<tr bgcolor=$select_color><td align=left colspan=2><font face=arial color=$num_color size=-1>$s-$z</font><img src=$img_url/zero.gif width=14 height=14><font face=arial size=-1><font face=arial color=$cel_color></font>$subject $lists[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$lists[5]</font></td></tr>\n";
			}
			else{
				print "<tr bgcolor=$cel_color><td align=left colspan=2><font face=arial color=$num_color size=-1>$s-$z</font><img src=$img_url/zero.gif width=14 height=14><font face=arial size=-1><font face=arial color=$cel_color></font><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num-$z>$subject $lists[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$lists[5]</font></td></tr>\n";
			}
			if ($datas[3] > 0) {            
				for($J=1;$J<=$datas[3];$J++) {
					if(-e "$main_dir/$num-$z-$J") {
						open(FILE,"<$main_dir/$num-$z-$J");
						@datasa = <FILE>;
						close (FILE);
						@listsa = split(/\|/, $datasa[1]);
						if($listsa[1]) { 
							$mailto = "<a href=mailto:$listsa[1]>$listsa[0]</a>";}else {$mailto = $listsa[0];
						}    
						$old_date = substr($listsa[4],0,10);
					    $rdate=substr($listsa[4],5,13);
						&getdate;
						$new_date = substr($date,0,10);	
						if($old_date eq $new_date) {
							$subject = "<img src=$img_url/newans.gif border=0>";} else{ $subject = "<img src=$img_url/ans.gif border=0>";
						}
						if($FORM{'number'} eq "$num-$z-$J"){
							print "<tr bgcolor=$select_color><td align=left colspan=2><font color=$num_color face=arial size=-1>$s-$z-$J</font><img src=$img_url/zero.gif width=17 height=14><font face=arial size=-1><font face=arial color=$cel_color></font>$subject $listsa[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsa[5]</font></td></tr>\n";
						}
						else{
							print "<tr bgcolor=$cel_color><td align=left colspan=2><font color=$num_color face=arial size=-1>$s-$z-$J</font><img src=$img_url/zero.gif width=17 height=14><font face=arial size=-1><font face=arial color=$cel_color></font><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num-$z-$J>$subject $listsa[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsa[5]</font></td></tr>\n";
						}
						if ($datasa[3] > 0) {            
							for($K=1;$K<=$datasa[3];$K++) {
								if(-e "$main_dir/$num-$z-$J-$K") {
									open(FILE,"<$main_dir/$num-$z-$J-$K");
									@datasab = <FILE>;
									close (FILE);
									@listsab = split(/\|/, $datasab[1]);
									if($listsab[1]) { 
										$mailto = "<a href=mailto:$listsab[1]>$listsab[0]</a>";}else {$mailto = $listsab[0];
									}     
									$old_date = substr($listsab[4],0,10);
									$rdate=substr($listsab[4],5,13);
									&getdate;
									$new_date = substr($date,0,10);
									if($old_date eq $new_date) {
										$subject = "<img src=$img_url/newans.gif border=0>";} else{ $subject = "<img src=$img_url/ans.gif border=0>";
									}  
									if($FORM{'number'}eq "$num-$z-$J-$K"){
										print "<tr bgcolor=$select_color><td align=left colspan=2><font color=$num_color  face=arial size=-1>$s-$z-$J-$K</font><img src=$img_url/zero.gif width=20 height=14><font face=arial size=-1><font face=arial color=$cel_color></font>$subject $listsab[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsab[5]</font></td></tr>\n";
									}
									else{
										print "<tr bgcolor=$cel_color><td align=left colspan=2><font color=$num_color  face=arial size=-1>$s-$z-$J-$K</font><img src=$img_url/zero.gif width=20 height=14><font face=arial size=-1><font face=arial color=$cel_color></font><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num-$z-$J-$K>$subject $listsab[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsab[5]</font></td></tr>\n";
									}
									if ($datasab[3] > 0) {            
										for($L=1;$L<=$datasab[3];$L++) {
											if(-e "$main_dir/$num-$z-$J-$K-$L") {
												open(FILE,"<$main_dir/$num-$z-$J-$K-$L");
												@datasabc = <FILE>;
												close (FILE);
												@listsabc = split(/\|/, $datasabc[1]);
												if($listsabc[1]) { 
													$mailto = "<a href=mailto:$listsabc[1]>$listsabc[0]</a>";}else {$mailto = $listsabc[0];
												}  
												$old_date = substr($listsabc[4],0,10);
												$rdate=substr($listsabc[4],5,13);
												&getdate;
												$new_date = substr($date,0,10);
												if($old_date eq $new_date) {
													$subject = "<img src=$img_url/newans.gif border=0>";} else{ $subject = "<img src=$img_url/ans.gif border=0>";
												}                
												if($FORM{'number'}eq "$num-$z-$J-$K-$L"){
													print "<tr bgcolor=$select_color><td align=left colspan=2><font color=$num_color face=arial size=-1>$s-$z-$J-$K-$L</font><img src=$img_url/zero.gif width=23 height=14><font face=arial size=-1><font face=arial color=$cel_color></font>$subject $listsabc[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsabc[5]</font></td></tr>\n";
												}
												else{
													print "<tr bgcolor=$cel_color><td align=left colspan=2><font color=$num_color face=arial size=-1>$s-$z-$J-$K-$L</font><img src=$img_url/zero.gif width=23 height=14><font face=arial size=-1><font face=arial color=$cel_color></font><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num-$z-$J-$K-$L>$subject $listsabc[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsabc[5]</font></td></tr>\n";
												}
												if ($datasabc[3] > 0) {            
													for($M=1;$M<=$datasabc[3];$M++) {
											            if(-e "$main_dir/$num-$z-$J-$K-$L-$M") {
															open(FILE,"<$main_dir/$num-$z-$J-$K-$L-$M");
												            @datasabcd = <FILE>;
												            close (FILE);
															@listsabcd = split(/\|/, $datasabcd[1]);
															if($listsabcd[1]) { 
																$mailto = "<a href=mailto:$listsabcd[1]>$listsabcd[0]</a>";}else {$mailto = $listsabcd[0];
															}        
															$old_date = substr($listsabcd[4],0,10);
															$rdate=substr($listsabcd[4],5,13);
								         					 &getdate;
															$new_date = substr($date,0,10);
															if($old_date eq $new_date) {
																$subject = "<img src=$img_url/newans.gif border=0>";} else{ $subject = "<img src=$img_url/ans.gif border=0>";
															}          
															if($FORM{'number'}eq "$num-$z-$J-$K-$L-$M"){
																print "<tr bgcolor=$select_color><td align=left colspan=2><font face=arial color=$num_color size=-1>$s-$z-$J-$K-$L-$M</font><img src=$img_url/zero.gif width=26 height=14><font face=arial size=-1><font face=arial color=$cel_color></font><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num-$z-$J-$K-$L-$M>$subject $listsabcd[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsabcd[5]</font></td></tr>\n";
															}
															else{
																print "<tr bgcolor=$cel_color><td align=left colspan=2><font face=arial color=$num_color size=-1>$s-$z-$J-$K-$L-$M</font><img src=$img_url/zero.gif width=26 height=14><font face=arial size=-1><font face=arial color=$cel_color></font><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num-$z-$J-$K-$L-$M>$subject $listsabcd[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsabcd[5]</font></td></tr>\n";
															}
															if ($datasabcd[3] > 0) {            
																for($N=1;$N<=$datasabcd[3];$N++) {
																    if(-e "$main_dir/$num-$z-$J-$K-$L-$M-$N") {
																		open(FILE,"<$main_dir/$num-$z-$J-$K-$L-$M-$N");
															            @datasabcde = <FILE>;
															            close (FILE);
																		@listsabcde = split(/\|/, $datasabcde[1]);
																		if($listsabcde[1]) {
																			$mailto = "<a href=mailto:$listsabcde[1]>$listsabcde[0]</a>";}else {$mailto = $listsabcde[0];
																		}  
																		$old_date = substr($listsabcde[4],0,10);
															            &getdate;
																		$rdate=substr($listsabcde[4],5,13);
															            $new_date = substr($date,0,10);
																		if($old_date eq $new_date) {
																			$subject = "<img src=$img_url/newans.gif border=0>";} else{ $subject = "<img src=$img_url/ans.gif border=0>";
																		}                
																		if($FORM{'number'}eq "$num-$z-$J-$K-$L-$M-$N"){
																			print "<tr bgcolor=$select_color><td align=left colspan=2><font face=arial color=$num_color size=-1>$s-$z-$J-$K-$L-$M-$N</font><img src=$img_url/zero.gif width=29 height=14><font face=arial size=-1><font face=arial color=$cel_color></font>$subject $listsabcde[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsabcde[5]</font></td></tr>\n";
																		}
																		else{																		
																			print "<tr bgcolor=$cel_color><td align=left colspan=2><font face=arial color=$num_color size=-1>$s-$z-$J-$K-$L-$M-$N</font><img src=$img_url/zero.gif width=29 height=14><font face=arial size=-1><font face=arial color=$cel_color></font><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num-$z-$J-$K-$L-$M-$N>$subject $listsabcde[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsabcde[5]</font></td></tr>\n";
																		}
																		if ($datasabcde[3] > 0) {            
																			for($O=1;$O<=$datasabcde[3];$O++) {
																	            if(-e "$main_dir/$num-$z-$J-$K-$L-$M-$N-$O") {
																					open(FILE,"<$main_dir/$num-$z-$J-$K-$L-$M-$N-$O");
																		            @datasabcdef = <FILE>;
																		            close (FILE);
																					@listsabcdef = split(/\|/, $datasabcdef[1]);
																					if($listsabcdef[1]) { 
																						$mailto = "<a href=mailto:$listsabcdef[1]>$listsabcdef[0]</a>";}else {$mailto = $listsabcdef[0];
																					}    
																					$old_date = substr($listsabcdef[4],0,10);
																					$rdate=substr($listsab[4],5,13);
																					&getdate;
																					$new_date = substr($date,0,10);
																					if($old_date eq $new_date) {
																						$subject = "<img src=$img_url/newans.gif border=0>";} else{ $subject = "<img src=$img_url/ans.gif border=0>";
																					}    
																					if($FORM{'number'}eq "$num-$z-$J-$K-$L-$M-$N-$O"){
																						print "<tr bgcolor=$select_color><td align=left colspan=2><font face=arial color=$num_color size=-1>$s-$z-$J-$K-$L-$M-$N-$O</font><img src=$img_url/zero.gif width=32 height=14><font face=arial size=-1><font face=arial color=$cel_color></font>$subject $listsabcdef[3]</font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsabcdef[5]</font></td></tr>\n";
																					}
																					else{	
																						print "<tr bgcolor=$cel_color><td align=left colspan=2><font face=arial color=$num_color size=-1>$s-$z-$J-$K-$L-$M-$N-$O</font><img src=$img_url/zero.gif width=32 height=14><font face=arial size=-1><font face=arial color=$cel_color></font><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num-$z-$J-$K-$L-$M-$N-$O>$subject $listsabcdef[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$rdate</font></td><td align=center><font face=arial size=-1 color=$read_color>$listsabcdef[5]</font></td></tr>\n";
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}																								
							}
						}
					}
				}
			}
		}
	}
}

sub view {
	open(VFILE, "$main_dir/$FORM{'number'}");
	@views = <VFILE>;
	close(VFILE);
	@Temp = split(/\|/, $views[1]);
	$pdate = substr($Temp[4],0,10);
	@md = split(/\//,$pdate);
	$year=$md[0];
	$month=$md[1];
	$sday=$md[2];
	$ptime = substr($Temp[4],12,5);
	@tm = split(/:/,$ptime);
	$stime = $tm[0];
	$smin = $tm[1];
	if($Temp[2] ne ""){
		$homepage="| <a href=$Temp[2] target=_blank><img src=$img_url/home.gif border=0 alt=\"Ȩ\"> <font color=$head_color>$Temp[2]</font></a>";
	}
	else{
		$homepage="";
	}
	@seper = split(/\|/,$views[2]);
	if ($seper[0] ne "1") { 
        $seper[1] =~ s/<br>/\r\n/g;
	    $seper[1] =~ s/<p>/\r\n\r\n/g;
	    $seper[1] =~ s/</&lt;/g;
        $seper[1] =~ s/>/&gt;/g;
        $seper[1] =~ s/"/&quot;/g;
        $seper[1] =~ s/\|/&#124;/g;
	    $seper[1] =~ s/&lt;hr&gt;/<hr>/g;
	}
	$seper[1] =~ s/\r\n\r\n/<p>/g;
    $seper[1] =~ s/\r\n/<br>/g;
    $seper[1] =~ s/\|/&#124;/g;
	$seper[1]=~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+)/$url <img src=$img_url\/home.gif> <a href=\"$1$2\" target=\"_new\">$1$2<\/a>/g;
    $seper[1]=~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$img_url\/mail.gif> <a href=\"mailto:$1\">$1<\/a>/g;
    if($seper[2] ne ""){
		$file_down = "<table border=0><tr><td><img src=$img_url/gul.gif border=0 alt=\"ٿε\"></td><td><a href=\"$cgi_url?id=$FORM{'id'}&num=$FORM{'number'}&action=down&file=$seper[2]\"><font color=blue>$seper[2]</font></a> [ <font color=red>$seper[3]</font> ]</td></tr></table>";   
		
		if(($seper[5] ne "") && ($seper[5] ne "http://")){
			$pre_view = "<table border=0><tr><td><img src=$img_url/view.gif border=0 alt=\"̸\"></td><td><a href=$seper[5] target=_blank><font size=-1 color=blue≯</font></a></td></tr></table>";
		}
	}
	elsif($seper[4] ne ""){
		$file_down = "<table border=0><tr><td><img src=$img_url/gul.gif border=0 alt=\"ٿε\"></td><td><a href=\"$cgi_url?id=$FORM{'id'}&num=$FORM{'number'}&action=down&file=$seper[4]\"><font color=blue>$seper[4]</font></a> [ <font color=red>ũ</font> ]</td></tr></table>";   
		
		if(($seper[5] ne "") && ($seper[5] ne "http://")){
			$pre_view = "<table border=0><tr><td><img src=$img_url/view.gif border=0 alt=\"̸\"></td><td><a href=$seper[5] target=_blank><font size=-1 color=blue≯</font></a></td></tr></table>";
		}
	}
	@apt = split(/-/,$FORM{'number'});
	$acou = @apt;

	if($views[3] eq "0") { 
		$subnumber = "$FORM{'number'}-1";
	}
	else { 
		$views[3]++;
		$subnumber = "$FORM{'number'}-$views[3]";
	}
	if($Temp[1]) { 
		$mailto = "<a href = mailto:$Temp[1]> <img src=$img_url/mail.gif border=0> <font color=$head_color>$Temp[0]</font> </a>"; 
	} 
	else{
		$mailto = "<font color=$head_color>$Temp[0]</font>";
	}
	&head;
	$link = "<table border=0 cellpadding=3 cellspacing=0><tr><td>$file_down</td><td>$pre_view</td></tr></table><br>\n";

print <<EOT;
<p>
<div align=center>
<table border=0 width=$width cellpadding=2 cellspacing=0>
<tr><td> &nbsp;  [ $mailto $homepage ] - <font color=$date_color>$year/$month/$sday ($stime:$smin)</font></td></tr>
<tr  bgcolor=$head_color><td>
<table width=100% cellpadding=1 cellspacing=0>
<tr>
<td><font color=$cel_color>  <b>$Temp[3]</b></font></td>
<td align=right><font color=$cel_color>Down [ <b>$Temp[5]</b> ]</font> <a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=modify&number=$FORM{'number'}><img src=$img_url/modify.gif border=0 alt=\" ϱ\"></a> <a href=$cgi_url?id=$FORM{'id'}&action=erase&number=$FORM{'number'}&subject=$Temp[3]><img src=$img_url/remove.gif border=0 alt=\" ϱ\"></a></td>
</tr></table></td>
</tr>
<tr bgcolor=$head_color><td align=center>
<table width=100% border=0 cellpadding=5 cellspacing=0 bgcolor=$cel_color>
<tr><td height=220 valign=top><font face=arial>$link $seper[1]</font></td></tr></table>
</td></tr>
</table>
</td</tr>
</table>
</div>
<div align=center>

<table width=$width cellspacing=0 cellpadding=2 border=0>
<tr><td align=right>
EOT
	if($FORM{'category'} eq ""){
		if($acou >= 8) {
			print "|<a href=$cgi_url?id=$FORM{'id'}&page=$page>Ϻ</a>|<a href=$cgi_url?id=$FORM{'id'}&action=form><b>ڷ ø</b></a>|\n";
		}
		else {
			print "|<a href=$cgi_url?id=$FORM{'id'}&action=reply&subnumber=$subnumber&number=$FORM{'number'}>亯ۼ</a>|<a href=$cgi_url?id=$FORM{'id'}&page=$page>Ϻ</a>|<a href=$cgi_url?id=$FORM{'id'}&action=form><b>ڷ ø</b></a>|\n";
		}
	}
	else{
			print "|<a href=$cgi_url?action=search&id=$FORM{'id'}&page=$page&category=$FORM{'category'}&keyword=$FORM{'keyword'}>˻ list </a>|<a href=$cgi_url?id=$FORM{'id'}> </a>|\n";
	}
	print "</td></tr></table></div>\n";
	print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
	$new = 1;
	if($FORM{'category'} eq ""){
		&display;
	}
	exit;
}

sub down_file {
		&lock;
	    &plus_num;
		&unlock;

		if(($FORM{'file'}=~ /http:\/\/.+/) || ($FORM{'file'}=~ /ftp:\/\/.+/)){
			print "Location:$FORM{'file'}\n\n";
		}
		else {
			print "Location:$main_url/files/$FORM{'file'}\n\n";	
		}	
		exit;
	#}
}

sub plus_num{
	open(VFILE, "$main_dir/$FORM{'num'}");
	@views = <VFILE>;
	close(VFILE);
	@Temp = split(/\|/, $views[1]);
	chop($Temp[5]);
	$Temp[5]++;
	open(NFI,">$main_dir/$FORM{'num'}");
	print NFI "$views[0]";
	print NFI "$Temp[0]|$Temp[1]|$Temp[2]|$Temp[3]|$Temp[4]|$Temp[5]\n";
	print NFI "$views[2]";
	print NFI "$views[3]";
	close(NFI);
}

sub head {
	print "Content-type: text/html\n\n";
	print "<html>\n";
	print "<head>\n";
	print "<title>$logo_txt</title>\n";
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
	print "<style type='text/css'>\n";
	print "<!--\n";
	print "A:link {color:black;text-decoration:none;}\n";
	print "A:visited {color:black;text-decoration:none;}\n";
	print "A:active {color:red;text-decoration:underline;}\n";
	print "A:hover {color:blue;text-decoration:underline;}\n";
	print ".ver8 {font-family:Verdana,Arial,;font-size:8pt}\n";
	print "p,br,body,td,select,input,form,textarea,option {font-size:10pt;}\n";
	print ".ad{border:1 solid black}\n";
	print ".cont{line-height:140%}\n";
	print "-->\n";
	print "</style>\n";
	print "<script language=\"JavaScript\">\n";
	print "function nextWin()\n";
	print "{location = \"$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}\"}\n";
	print "</script>\n";
	print "</head>\n";
	if($background ne ""){
		$back="background=$background";
	}
	else{
		$back="bgcolor=$bgcolor";
	}
	if( $FORM{'action'} eq "modify_ok" ){
		print "<body $back onLoad=\"setTimeout(\'nextWin()\',0)\">\n";
	}
	else{
		print "<body $back>\n";
	}
	if($logo_img ne ""){
		print "<center><a href=$cgi_url?id=$FORM{'id'}&action=admin_login><img src=$logo_img border=0 alt=\"  մϴ.\"></a>\n";
	}
	else{
		print "<center><div align=center><table cellpadding=2 cellspacing=0 border=0  bgcolor=$head_color><tr><td>\n";
		print "<table width=100% cellpadding=3 cellspacing=0 border=0 bgcolor=$cel_color><tr><td  align=center> &nbsp; <a href=$cgi_url?id=$FORM{'id'}&action=admin_login>";
		print "<font color=$head_color>$logo_txt</font></a> &nbsp; </td></tr></table></td></tr></table></div>\n";
	}
	print "<p>\n";
}

sub foot {
	print "<p>\n";
	print "<a href=\"http://ychat.sarang.net/\" target=\"blank\"><font color=blue>created by y-chat</font></a> &nbsp;  <a href=\"http://sepal.woorizip.com\" target=\"_blank\"><font color=red>modified by sepal</font></a>\n";
	print "</center></body></html>\n";
	exit;
}

sub input_form{
	&read_cookie;
	&head;
print <<START;
<form method=post enctype=multipart/form-data action=$cgi_url>
<input type=hidden name=action value=write>
<input type=hidden name=id value=$FORM{'id'}>
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td><table border=0 cellpadding=3 cellspacing=3 bgcolor=$head_color><tr><td align=center><font face=arial color=$cel_color size=-1>&nbsp;&nbsp; &nbsp;&nbsp;  </font></td><td><input type=text name=name value=\"$COOKIE{'UN'}\" size=30 maxlength="10" style="background-color:#ffffff;border:1 solid $head_color"> </td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>e-m a i l</font></th><td><input type=text name=email value=\"$COOKIE{'UM'}\" size=30 style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>Ȩ</font></th><td>
START
	if($COOKIE{'UH'} eq "") {
		print"<input type=text name=homepage size=30 value=\"http://\" style=\"background-color:#ffffff;border:1 solid $head_color\">\n";
	}
	else{
		print"<input type=text name=homepage size=30 value=\"$COOKIE{'UH'}\" style=\"background-color:#ffffff;border:1 solid $head_color\">\n";
	}
print <<END;
</td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>йȣ</font></th><td><input type=password name=passwd size=8 style="background-color:#ffffff;border:1 solid $head_color"> <font face=arial size=-1 color=$cel_color> ʿ</font> <input type=checkbox name=html value=1><font face=arial size=-1 color=$cel_color>html</font></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color> &nbsp;&nbsp; &nbsp;&nbsp;</font></th><td><input type=text name=subject size=40 maxlength="66" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color≯</font></th><td><input type=text name=pre_view size=40 maxlength="66" value="http://" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td colspan=2 align=center><textarea name=comments rows=8 cols=55 style="background-color:#ffffff;border:1 solid $head_color"></TextArea></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>÷</font></td><td><input name=file_name type=file size=40 style="width:90%;border:1 solid black"></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>ũ</font></td><td><input name=link_file type=text size=40 style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td align=center colspan=2><input type=submit value="ڷø" style="background-color:$cel_color;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<font face=arial size=-1>[ <a href=$cgi_url?id=$FORM{'id'}>ڷǷ ư</a> ]</font>
END
	&foot;
}

sub notice_form{
	if($FORM{'passwd'} eq $admin){
		&head;
print <<START;
<p>
[ ]
<form method=post action=$cgi_url>
<input type=hidden name=action value=adminwrite>
<input type=hidden name=id value=$FORM{'id'}>
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td>
<table border=0 cellpadding=3 cellspacing=3 bgcolor=$head_color>
</td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color></font></th><td>
<input type=text name=die_year size=4 maxlength=4 style="background-color:#ffffff;border:1 solid $head_color"><font face=arial size=-1 color=$cel_color></font>
<input type=text name=die_mon size=2 maxlength=2 style="background-color:#ffffff;border:1 solid $head_color"><font face=arial size=-1 color=$cel_color></font> 
<input type=text name=die_day size=2 maxlength=2 style="background-color:#ffffff;border:1 solid $head_color"><font face=arial size=-1 color=$cel_color>
(: 20000801)</font></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color> &nbsp;&nbsp; &nbsp;&nbsp;</font></th><td><input type=text name=subject size=40 maxlength="66" style="background-color:#ffffff;border:1 solid $head_color"> <input type=checkbox name=html value=1><font face=arial size=-1 color=$cel_color>html</font></td></tr>
<tr><td colspan=2 align=center><textarea name=comments rows=8 cols=55 style="background-color:#ffffff;border:1 solid $head_color"></TextArea></td></tr>
<tr><td align=center colspan=2><input type=submit value="ڷø" style="background-color:$cel_color;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<font face=arial size=-1>[ <a href=$cgi_url?id=$FORM{'id'}>ڷǷ ư</a> ]</font>
START
		&foot;
	}
	else{
			$err = pass;
			&error;
	}
}

sub modify_form {
	open(DATA,"<$main_dir/$FORM{'number'}");
	@data = <DATA>;
	chop(@data);
	$pass=$data[0];
	@wdata= split(/\|/,$data[1]);
	$name=$wdata[0];
	$email=$wdata[1];
	$homepage=$wdata[2];
	$subject=$wdata[3];
	$wdate=$wdata[4];
	$readnum=$wdata[5];
	@seper= split(/\|/,$data[2]);
	$html=$seper[0];
	if ($html eq "1") {
		$htmlvalue = "checked";
	}
	else{
		$htmlvalue = "";
	}
	$seper[1] =~ s/<br>/\n/g;
	$comment=$seper[1];
	$file_name=$seper[2];
	$file_size=$seper[3];
	$link_file=$seper[4];
	$pre_view=$seper[5];
	$ansnum=$data[3];
	close (DATA);

	&head;
print <<START;
<form method=post action=$cgi_url>
<input type=hidden name=action value="modify_ok">
<input type=hidden name=id value="$FORM{'id'}">
<input type=hidden name=page value="$FORM{'page'}">
<input type=hidden name=number value="$FORM{'number'}">
<input type=hidden name=ansnum value="$ansnum">
<input type=hidden name=readnum value="$readnum">
<input type=hidden name=date value="$wdate">
<input type=hidden name=file_name value="$file_name">
<input type=hidden name=file_size value="$file_size">
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td><table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td align=center><font face=arial color=$cel_color size=-1>&nbsp;&nbsp; &nbsp;&nbsp;  </font></td><td><input type=text name=name size=30 maxlength="10" value="$name" style="background-color:#ffffff;border:1 solid $head_color"> </td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>e-m a i l</font></th><td><input type=text name=email size=30 value="$email" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>Ȩ</font></th><td><input type=text name=homepage size=30 value="$homepage" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<input type=hidden name=passwd size=8 value="$pass">
<tr><td align=center><font face=arial size=-1 color=$cel_color> &nbsp;&nbsp; &nbsp;&nbsp;</font></th><td><input type=text name=subject size=40 maxlength="66" value="$subject" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color≯</font></th><td><input type=text name=pre_view size=40 maxlength="66" value="$pre_view" style="background-color:#ffffff;border:1 solid $head_color"> <input type=checkbox name=html value=1 $htmlvalue><font face=arial size=-1 color=$cel_color>html</font></td></tr>
<tr><td colspan=2 align=center><textarea name=comments rows=8 cols=55 style="background-color:#ffffff;border:1 solid $head_color">$comment</TextArea></td></tr>
START

if(($file_name eq "") && ($link_file ne "")){
		print"<tr><td align=center><font face=arial size=-1 color=$cel_color>ũ</font></td><td><input name=link_file type=text size=40 value=\"$link_file\" style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>\n";
}

print <<END;
<tr><td align=center colspan=2><input type=submit value="ϱ" style="background-color:$cel_color;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<font face=arial size=-1>[ <a href=$cgi_url?id=$FORM{'id'}>ڷǷ ư</a> ]</font>
END

	&foot;

}

sub admin_modify_form {
	open(DATA,"<$main_dir/notice.txt");
	@data = <DATA>;
	@notice = split(/\|/,$data[0]);
	$html=$notice[0];
	$subject = $notice[1];
	$notice[2] =~ s/<br>/\n/g;
	$comment = $notice[2];
	$wdate = $notice[3];
	@die_date=split(/:/,$notice[4]);
	$die_year = $die_date[0];
	$die_mon = $die_date[1];
	$die_day = $die_date[2];
	$read_num = $notice[5];
	if ($html eq "1") {
		$htmlvalue = "checked";
	}
	else{
		$htmlvalue = "";
	}
	close (DATA);

	&head;
print <<START;
<p>
[ ϱ]
<form method=post action=$cgi_url>
<input type=hidden name=action value=adminwrite>
<input type=hidden name=read_num value=$read_num>
<input type=hidden name=id value=$FORM{'id'}>
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color><tr><td>
<table border=0 cellpadding=3 cellspacing=3 bgcolor=$head_color>
</td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color></font></th><td>
<input type=text name=die_year size=4 maxlength=4 value="$die_year" style="background-color:#ffffff;border:1 solid $head_color"><font face=arial size=-1 color=$cel_color></font>
<input type=text name=die_mon size=2 maxlength=2 value="$die_mon" style="background-color:#ffffff;border:1 solid $head_color"><font face=arial size=-1 color=$cel_color></font> 
<input type=text name=die_day size=2 maxlength=2 value="$die_day" style="background-color:#ffffff;border:1 solid $head_color"><font face=arial size=-1 color=$cel_color>
(: 20000801)</font></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color> &nbsp;&nbsp; &nbsp;&nbsp;</font></th><td><input type=text name=subject size=40 maxlength="66" value="$subject" style="background-color:#ffffff;border:1 solid $head_color"> <input type=checkbox name=html value=1 $htmlvalue><font face=arial size=-1 color=$cel_color>html</font></td></tr>
<tr><td colspan=2 align=center><textarea name=comments rows=8 cols=55 style="background-color:#ffffff;border:1 solid $head_color">$comment</TextArea></td></tr>
<tr><td align=center colspan=2><input type=submit value="ڷø" style="background-color:$cel_color;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<font face=arial size=-1>[ <a href=$cgi_url?id=$FORM{'id'}>ڷǷ ư</a> ]</font>
START
	&foot;
}

sub read_cookie{

    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
        ($name,$value) = split(/=/,$_);
        $COOKIE{$name} = $value;
        }
	}
}

sub admin_login {
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<table border="0" cellpadding="2" cellspacing="0" width="430" bgcolor="$head_color">
    <tr>
        <td><table border="0" cellpadding="2" cellspacing="0" width="100%"
             bgcolor="$cel_color">
                <tr>
                    <td height=120><p align="center"><font size="2" color="red"> </font> մϴ.<br> йȣ  ֽð Ȯ ư  
                        ּ.
						<form method=post action=$cgi_url>
						<input type=hidden name=id value=$FORM{'id'}>
						<input type=hidden name=action value=loginok>
						<div align=center><table><tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:$cel_color;border:1 solid $head_color"></td><td><input type=submit value=\"Ȯ\" style="color:black;background-color:$cel_color;border:1 solid $head_color;height:21px"></td><td>
						</td></tr></table></div>
						</form>
					</td>
                </tr>
	           </table></td>
    </tr>
</table>
START
&foot;
}

sub admin_ok {
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<table border="0" cellpadding="2" cellspacing="0" width="430" bgcolor="$head_color">
    <tr>
        <td><table border="0" cellpadding="2" cellspacing="0" width="100%"
             bgcolor="$cel_color">
                <tr>
                    <td height=120><p>&nbsp;<p align="center"><font size="2" color="red"> մϴ.<br> йȣ  ֽð Ȯ ư  
                       ּ.</font>
						<form method=post action=$cgi_url>
						<input type=hidden name=id value=$FORM{'id'}>
						<input type=hidden name=action value=admin_ok>
						<div align=center><table>
						<tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:$cel_color;border:1 solid $head_color"></td><td><input type=submit value="Ȯ" style="color:black;background-color:$cel_color;border:1 solid $head_color;height:21px">
						</td></tr></table>
						</div>
						</form>
					</td>
                </tr>
            </table></td>
    </tr>
</table>
START
&foot;
}

sub admin_remove {
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<table border="0" cellpadding="2" cellspacing="0" width="430" bgcolor="$head_color">
    <tr>
        <td><table border="0" cellpadding="2" cellspacing="0" width="100%"
             bgcolor="$cel_color">
                <tr>
                    <td height=120><p align="center"><font size="2" color="red"> մϴ.<br> йȣ  ֽð Ȯ ư  
                        ּ.</font>
						
						<form method=post action=$cgi_url>
								<input type=hidden name=id value=$FORM{'id'}>
								<input type=hidden name=action value=admin_remove_ok>
								<div align= center><table><tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:$cel_color;border:1 solid $head_color"></td><td><input type=submit value=\"Ȯ\" style="color:black;background-color:$cel_color;border:1 solid $head_color;height:21px"></td><td>
								</td></tr>
								</table></div>
						</form>
						</td>
                </tr>
            </table></td>
    </tr>
</table>


START
&foot;
}

sub enterpass{
	&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
<H2>йȣ ԷϽÿ.</H2>

<form method=post action=$cgi_url>
<input type=hidden name=action value=passok>
<input type=hidden name=page value=$FORM{'page'}>
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=number value=$FORM{'number'}>
<table><tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:#ffffff;border:1 solid $head_color"></td><td><input type=submit value="enter" style="background-color:$cel_color;border:1 solid $head_color;height:20"></td><td></form></td></tr></table>
START
	&foot;
}

sub passok{
	if($FORM{'passwd'} eq ""){
		$err = pass;
		&error;
	}
	$pass = crypt($FORM{'passwd'},sp);
	open(FILE,"<$main_dir/$FORM{'number'}");
	@filea = <FILE>;
	close (FILE);
	chop($filea[0]);
	if(($filea[0] eq $pass) || ($admin eq $pass)) {
		&modify_form;
	}else{
		$err = pass;
		&error;
	}
}

sub write {
	print "Set-Cookie: UN=$FORM{'name'}; expires=Sunday, 12-Dec-2000 12:12:12 GMT;\r\n";
	print "Set-Cookie: UM=$FORM{'email'}; expires=Sunday, 12-Dec-2000 12:12:12 GMT;\r\n";
	print "Set-Cookie: UH=$FORM{'homepage'}; expires=Sunday, 12-Dec-2000 12:12:12 GMT;\r\n";
	
	$pass = crypt($FORM{'passwd'},sp);
	
	if(($admin_only eq "yes") && ($admin ne $pass)){
		$err = admin;
		&error;
	}
	
	if($FORM{'file_name'} ne ""){
		if($FORM{'link_file'} eq ""){
			&upload_file;
		}
		else{
			$err = double;
			&error;
		}
	}
	elsif($FORM{'link_file'} ne ""){
		if(($FORM{'link_file'} =~ /^http:\/\//) || ($FORM{'link_file'}=~ /^ftp:\/\//)) {
        }
        else {
			$err = "link";
            &error;
        }
	}

	$FORM{'comments'} =~ s/\cM//g;
	$FORM{'comments'} =~ s/\n/<br>/g;
	$lengh = length($FORM{'comments'});
	if($FORM{'subnumber'} eq "") {
		open(Num,"<$main_dir/data.txt");
		$num = <Num>;
		close(Num);   
		&lock;
		open(Num,">$main_dir/data.txt");
		$num = $num+1;
		print Num "$num\n";
		close(Num);   
		open(WF,"$main_dir/main.txt");
		$cou = <WF>;
		close(WF);

		$cou++;
		open(WF,">$main_dir/main.txt");
		print WF "$cou";
		close(WF);
		&unlock;
	}
	if(($FORM{'homepage'} ne "") && $FORM{'homepage'} ne "http://"){
		$home="$FORM{'homepage'}";	}
	else{
	$home="";
	}
	&getdate;
	if($FORM{'subnumber'} eq "") {
		open(WFILE,">$main_dir/$num");
		print WFILE "$pass\n";
		print WFILE "$FORM{'name'}|$FORM{'email'}|$home|$FORM{'subject'}|$date|0\n";
		print WFILE "$FORM{'html'}|$FORM{'comments'}|$org_name|$size|$FORM{'link_file'}|$FORM{'pre_view'}|\n";
        print WFILE "0\n";
		close(WFILE);
	}
	else {
		open(Sum,"<$main_dir/$FORM{'num'}");
		@est = <Sum>;
		close(Sum);   
		@mail = split(/\|/,$est[1]);
		$addr = $mail[1];

		chop($est[3]);
		$est[3]++;
		open(Suma,">$main_dir/$FORM{'num'}");
		print Suma "$est[0]";
		print Suma "$est[1]";
		print Suma "$est[2]";
		print Suma "$est[3]\n";
		close(Suma);

		open(WFILE,">$main_dir/$FORM{'subnumber'}");
		print WFILE "$pass\n";
		print WFILE "$FORM{'name'}|$FORM{'email'}|$home|$FORM{'subject'}|$date|0\n";
		print WFILE "$FORM{'html'}|$FORM{'comments'}|$org_name|$size|$FORM{'link_file'}|$FORM{'pre_view'}|\n";
		print WFILE "0\n";
		close(WFILE);
		
		if(($addr) && ($smail eq "yes")) {
			&sendmail; 
		}
	}            
	if($num > $max_data ) {
		$count = 0;
		until($num <= 0) {
			if (-e "$main_dir/$num") {
					$count = ($count + 1); 
			}
			$num = ($num - 1);
			if($count >= $max_data) {
				last  
			}
		}
        until($num <=0) {

			open(FILE,"<$main_dir/$num");
			@filea = <FILE>;
			@seper = split(/\|/,$filea[2]);
			close (FILE);
			unlink ("$main_dir/$num");
			unlink ("$main_dir/files/$seper[2]");
			if($filea[3] > 0) {
				&rurease;
			}
			$num = ($num - 1);
		}
	}
	&lock;
	open(WF,">$data_dir/$in{'id'}/main.txt");
	print WF "$max_data";
	close(WF);
	&unlock;
	&display;
}

 sub upload_file {
	$upfile = $FORM{'file_name'};
	@a = split(/\"/,$real_file);
	@b = split(/\\/,$a[3]);
	$t = @b;
	$org_name = ($b[$t-1]);
	$filename = "$main_dir/files/".$org_name;
	if(-e $filename){
		$err = exist;
		&error;
	}
    open(FILE, ">$filename") || exit(1);
    binmode FILE; 
    print FILE $upfile;
    close FILE;
	$size = (-s "$main_dir/files/$org_name");
	if($size > ($max_size*1048576)){
		unlink("$main_dir/files/$org_name");
		$err = size;
		&error;
	}
	
	if($size >= 1048576) { 
		$size = substr(($size/1048576),0,3);
		@dot=split(/\./,$size);
		if($dot[1] eq ""){
			$size = "$dot[0] MB";
		}
		else{
			$size = "$size MB";
		}
	}
	elsif($size >= 1024) {
		$size = substr(($size/1024),0,3);
		@dot=split(/\./,$size);
		if($dot[1] eq ""){
			$size = "$dot[0] KB";
		}
		else{
			$size = "$size KB";
		}
	}
	else{
		$size = "$size byte";
	}

}

sub modify {
	$FORM{'comments'} =~ s/\cM//g;
	$FORM{'comments'} =~ s/\n/<br>/g;
	$lengh = length($FORM{'comments'});

	open(WFILE,">$main_dir/$FORM{'number'}");
	print WFILE "$FORM{'passwd'}\n";
	print WFILE "$FORM{'name'}|$FORM{'email'}|$FORM{'homepage'}|$FORM{'subject'}|$FORM{'date'}|$FORM{'readnum'}\n";
	print WFILE "$FORM{'html'}|$FORM{'comments'}|$FORM{'file_name'}|$FORM{'file_size'}|$FORM{'link_file'}|$FORM{'pre_view'}|\n";
    print WFILE "$FORM{'ansnum'}\n";
	close(WFILE);

	&display;
}

sub adminwrite {
	$FORM{'comments'} =~ s/\cM//g;
	$FORM{'comments'} =~ s/\n/<br>/g;
	$lengh = length($FORM{'comments'});
	&getdate;
	open(WFILE,">$main_dir/notice.txt");
	if($FORM{'read_num'} eq ""){
		print WFILE "$FORM{'html'}|$FORM{'subject'}|$FORM{'comments'}|$date|$FORM{'die_year'}:$FORM{'die_mon'}:$FORM{'die_day'}|0|\n";
	}
	else{
		print WFILE "$FORM{'html'}|$FORM{'subject'}|$FORM{'comments'}|$date|$FORM{'die_year'}:$FORM{'die_mon'}:$FORM{'die_day'}|$FORM{'read_num'}|\n";
	}
	close(WFILE);
	&display;
}

sub reply_form {
	&read_cookie;
	&head;
	open(Replay, "$main_dir/$FORM{'number'}");
	@repl = <Replay>;
	close(Replay);
		
	@repla = split(/\|/, $repl[1]);	
	@seper = split(/\|/, $repl[2]);	
	$seper[1] =~ s/<br>/\n>/g;
	$seper[1] =~ s/<hr>/\n<hr>\n>/g;
	$seper[1] =~ s/textarea/ýƮ /g;
	$repla[3] =~ s/\"/ /g;

	@arp = split(/-/,$FORM{'number'});
	$scut = @arp;
	if($scut < 2) { $ford = ":";}

print <<START;
<form method=post action=$cgi_url enctype=multipart/form-data>
<input type=hidden name=action value=write>
<input type=hidden name=subnumber value=$FORM{'subnumber'}>
<input type=hidden name=num value=$FORM{'number'}>
<input type=hidden name=id value=$FORM{'id'}>
<table border=0 cellpadding=3 cellspacing=0 bgcolor=$head_color>
<tr bgcolor=$ncel_color><td><font size=-1 color=$head_color> <b>$repla[0]</b>Բ  ۿ 亯 ۼ</font></td></tr>
<tr><td>
<table border=0 cellpadding=3 cellspacing=2 bgcolor=$head_color>
<tr><td align=center><font face=arial color=$cel_color size=-1> &nbsp; &nbsp;&nbsp; </font></td><td><input type=text name=name size=20 value=\"$COOKIE{'UN'}\" style=\"background-color:#ffffff;border:1 solid $head_color\"> </td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>e-m a i l</font></th><td><input type=text name=email size=30 value=\"$COOKIE{'UM'}\" style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>Ȩ</font></th><td>
START
	if($COOKIE{'UH'} eq "") {
		print"<input type=text name=homepage value=\"http://\" size=30 style=\"background-color:#ffffff;border:1 solid $head_color\">\n";
	}
	else{
		print"<input type=text name=homepage value=\"$COOKIE{'UH'}\" size=30 style=\"background-color:#ffffff;border:1 solid $head_color\">\n";
	}
print <<MID;
</td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>йȣ</font></th><td><input type=password name=passwd size=8 style=\"background-color:#ffffff;border:1 solid $head_color\"><font face=arial size=-1 color=$cel_color> ʿ</font> <input type=checkbox name=html value=1><font size=-1 color=$cel_color>html</font></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color> &nbsp; &nbsp; &nbsp;</font></th><td><input type=text name=subject size=40 value="$ford$repla[3]" style=\"background-color:#ffffff;border:1 solid $head_color\"></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color≯</font></th><td><input type=text name=pre_view size=40 maxlength="66" value="http://" style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td colspan=2 align=center><textarea name=comments rows=8 cols=55 style="background-color:#ffffff;border:1 solid $head_color">
MID

print "\n\n<hr>\n\n>[$repla[0]Բ  ]\n\n>$seper[1]";

print <<END;
</textarea></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>÷</font></td><td><input name=file_name type=file size=40 style="width:90%;border:1 solid black"></td></tr>
<tr><td align=center><font face=arial size=-1 color=$cel_color>ũ</font></td><td><input name=link_file type=text size=40 style="background-color:#ffffff;border:1 solid $head_color"></td></tr>
<tr><td align=center colspan=2><input type=submit value="ڷø" style="background-color:$cel_color;border:1 solid $head_color;height:20"> <input type=reset value="ٽۼ" style="background-color:$cel_color;border:1 solid $head_color;height:20"></td></tr></table></td></tr></table>
</form>
<font face=arial size=-1>[ <a href=$cgi_url?id=$FORM{'id'}>ڷǷ ư</a> ]</font>
END
	&foot;
}

sub getdate {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	if ($sec < 10)  { $sec = "0$sec";   }
	if ($min < 10)  { $min = "0$min";   }
	if ($hour < 10) { $hour = "0$hour"; }
	if ($mday < 10) { $mday = "0$mday"; }
	if ($mon < 10)  { $mon = "0$mon";  }
	$month = ($mon + 1);
	if ($month < 10)  { $month = "0$month";  }
	if($year ne "99"){
		if($year > 100){
			$year=($year-100)+2000;
		}
		elsif($year < 10){
			$year=2000+$year;	
		}
		else{
			$year="2000";
		}
	}
	else{
		$year="1999";
	}
	$date = "$year/$month/$mday [$hour:$min]"; 
}

sub error {
  &head;
  if($err eq id) {
	  print "<h2><u>ڷ̸ </u></h2>\n";
	  print "ϰ 䱸ϴ ڷ ã  ϴ<br>\n";
	  print "ݵ pds.cgi?<font color=red>id=db</font>  ҷ մϴ.\n";
  }
  elsif($err eq pass) {
	 print "<H2><u>йȣ </u></H2>\n";
	 print "йȣ ġ ʽϴ.\n";
  }
  elsif($err eq admin) {
	 print "<H2><u>йȣ </u></H2>\n";
	 print " ڷ ڸ    ֽϴ.<br>  йȣ ġ ʽϴ.\n";
  }
  elsif($err eq "exist") {
	 print "<H2><u> ̸  մϴ. </u></H2>\n";
	 print "̸ ٲٽ ÷ּ...\n";
  }
  elsif($err eq keyword) {
	 print "<H2><u>˻ Է </u></H2>\n";
	 print "˻ ԷϽ ̾<br>˻Ϸ ˻ Էϼ\n";
  }
  elsif($err eq size) {
	 print "<H2><u>  ʹ Ŀ... </u></H2>\n";
	 print " ø ִ <font color=blue>ִ 뷮</font> ϴ <font color=red>$max_size MB</font> Դϴ.<br>ڷ 뷮    ÷ּ.\n";
  }
  elsif($err eq double) {
	 print "<H2><u> ϳ մϴ. </u></H2>\n";
	 print "<font color=red>ϸũ</font> <font color=red>Ͼε</font>  ϳ  ּ...\n";
  }
  elsif($err eq "link") {
		print "<H2><u>ȭ ũ <font color=red>http:\/\/</font> Ǵ <font color=red>ftp:\/\/</font>   ؾ մϴ.</u></H2>";
	}
  else{
	 print "<H2><u>ڷ ۼ </u></H2>\n";
	 print "̸, ,  ݵ äž մϴ\n";
  }
  print "<p>ڷ ư ٽ õ Ͻʽÿ.<br><br>\n";
  print "<a href=\"javascript:history.go(-1)\">ٽýõ(BACK)</a>\n";
  &foot;	
  exit;
}

sub search {
	opendir(SEAR, "$main_dir");
	@num_data = readdir(SEAR);
	$fil_data = @num_data-6;
	closedir(SEAR);
            
	$cou = 0;
	@remain = "";
	foreach $dataa (@num_data) {
		if(($dataa ne "data.txt") && ($dataa ne "main.txt")) {
			open(AAA, "$main_dir/$dataa");
			@sea = <AAA>;
			@sdata =split(/\|/, $sea[1]);
			@sdata2= split(/\|/,$sea[2]);
			close (AAA);
			
			if($FORM{'category'} eq "subject") { 
				$search_data=$sdata[3];
			}
			elsif($FORM{'category'} eq "comment"){
				$search_data=$sdata2[1];
			}
			elsif($FORM{'category'} eq "name"){
				$search_data=$sdata[0];
			}
			else{
				$category = "all";
			}
			foreach $qst (@sea) {
				if($category eq "all"){
					$search_data=$qst;
				}

				if($search_data =~ /$FORM{'keyword'}/i) { 
					$remain[$cou] = $dataa;
					$cou++;
					last;
				}
			}
		} 
	}

	$tot_pg = int($cou/$page_num);
	if(($tot_pg*$page_num) < $cou) {$tot_pg = $tot_pg + 1; }
	&head;
	@remain = sort(@remain);
	if(($FORM{'page'} eq "") || ($FORM{'page'} ==1)) {
		$d = 0;
		$s = 0;
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		if($tot_pg <= 1) {
			print "<table width=$widthcellspacing=0 cellpadding=2 border=0><tr><td width=160 align=left>|<a href=$cgi_url?id=$FORM{'id'}&action=form><b><font color=blue><font color=$head_color>ڷ ø</font></font></b></a>|</td><td align=center><font face=arial size=-1><b>˻:</b> <font color=red>$FORM{'keyword'}</font>&nbsp;&nbsp;&nbsp; <b>˻:</b> <font color=red>$cou</font></font></td><td width=160 align=right>|||</td></tr></table>\n";
		}
		else {
			print "<table width=$width cellspacing=0 cellpadding=2 border=0><tr><td width=160 align=left>|<a href=$cgi_url?id=$FORM{'id'}&action=form><b><font color=blue><font color=$head_color>ڷ ø</font></font></b></a>|</td><td align=center><font face=arial size=-1><b>˻:</b> <font color=red>$FORM{'keyword'}</font>&nbsp;&nbsp;&nbsp; <b>˻:</b> <font color=red>$cou</font></font></td><td width=160 align=right>||<a href=$cgi_url?action=$FORM{'action'}&id=$FORM{'id'}&category=$FORM{'category'}&keyword=$FORM{'keyword'}&page=2></a>|</td></tr></table>\n";
		}
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		print "<table width=$width border=0 cellpadding=2 cellspacing=0 bgcolor=$head_color><tr align=center><td width=13 align=left><font color=$cel_color></font></td><td  align=center><font face=arial size=-1 color=$cel_color>  </font></td><td align=center><font face=arial size=-1 color=$cel_color> &nbsp; </font></td><td align=center><font face=arial size=-1 color=$cel_color>ۼϽ</font></td><td width=30 align=center><font face=arial size=-1 color=$cel_color>Down</font></td></tr>\n";

		if($cou >= 1) {
			foreach $num (@remain) {
				open(FILE,"<$main_dir/$num");
				@data = <FILE>;
				close (FILE);
				$d = ($d+1);
				$s++;
				@list = split(/\|/, $data[1]);
				if($list[1]) { 
					$mailto = "<a href=mailto:$list[1]>$list[0]</a>";}else {$mailto = $list[0];
				}           
				$old_date = substr($list[4],0,10);
				&getdate;
				$new_date = substr($date,0,10);
				if($old_date eq $new_date) {
					$subject = "<img src=$img_url/newgul.gif border=0>";} else{ $subject = "<img src=$img_url/gul.gif border=0>";
				}       
				print "<tr bgcolor=$cel_color><td><font color=$num_color face=arial size=-1>$num</font></td><td align=left><font face=arial size=-1><a href=$cgi_url?id=$FORM{'id'}&page=$FORM{'page'}&action=view&number=$num&category=$FORM{'category'}&keyword=$FORM{'keyword'}>$subject $list[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$list[4]</font></td><td align=center><font face=arial size=-1 color=$read_color>$list[5]</font></td></tr>\n";

				if($d >= $page_num) { $page=1; last;  }
			 }
         }
         else {
			print "<tr bgcolor=$cel_color><td align=center><font face=arial size=-1><b>$d</b></font></td><td align=right><font face=arial size=-1 color=red><b>ãô  !</b></font></td><td align=center></td><td align=center></td><td align=center></td></tr>\n";
        }
    }
	if(($FORM{'page'} ne "") &&($FORM{'page'} !=1)) {
		$scount = (($FORM{'page'}-1)*$page_num);
		$icount = 0;
		$d = 0; 
		$pre_pg= $FORM{'page'} - 1;
		$next_pg = $FORM{'page'} + 1;
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		if($next_pg <= $tot_pg) {
			print "<table width=$width cellspacing=0 cellpadding=2 border=0><tr><td width=160 align=left>|<a href=$cgi_url?id=$FORM{'id'}&action=form><b><font color=blue><font color=$head_color>ڷ ø</font></font></b></a>|</td><td align=center><font face=arial size=-1><b>˻:</b> <font color=red>$FORM{'keyword'}</font>&nbsp;&nbsp;&nbsp; <b>˻:</b> <font color=red>$cou</font></font></td><td width=160 align=right>|<a href=$cgi_url?action=$FORM{'action'}&id=$FORM{'id'}&category=$FORM{'category'}&keyword=$FORM{'keyword'}&page=$pre_pg></a>|<a href=$cgi_url?action=$FORM{'action'}&id=$FORM{'id'}&category=$FORM{'category'}&keyword=$FORM{'keyword'}&page=$next_pg></a>|</td></tr></table>\n";
		}
		else {
			print "<table width=$width cellspacing=0 cellpadding=2 border=0 ><tr><td width=160 align=left>|<a href=$cgi_url?id=$FORM{'id'}&action=form><b><font color=blue><font color=$head_color>ڷ ø</font></font></b></a>|</td><td align=center><font face=arial size=-1><b>˻:</b> <font color=red>$FORM{'keyword'}</font>&nbsp;&nbsp;&nbsp; <b>˻:</b> <font color=red>$cou</font></font></td><td width=160 align=right>|<a href=$cgi_url?action=$FORM{'action'}&id=$FORM{'id'}&category=$FORM{'category'}&keyword=$FORM{'keyword'}&page=$pre_pg></a>||</td></tr></table>\n";
		}
		print "<table width=$width cellspacing=0 cellpadding=0 border=0><tr><td bgcolor=#000000 width=100% height=2><img src=$img_url/zero.gif width=0 height=0 border=0></td></tr></table>\n";
		print "<table width=$width border=0 cellpadding=2 cellspacing=0 bgcolor=$head_color><tr align=center><td width=13 align=left><font color=$cel_color></font></td><td  align=center><font face=arial size=-1 color=$cel_color>  </font></td><td align=center><font face=arial size=-1 color=$cel_color> &nbsp; </font></td><td align=center><font face=arial size=-1 color=$cel_color>ۼϽ</font></td><td width=30 align=center><font face=arial size=-1 color=$cel_color>Down</font></td></tr>\n";

		foreach $num (@remain) {
			$icount = $icount + 1;
			if($icount > $scount) {
				open(FILE,"<$main_dir/$num");
				@data = <FILE>;
				close (FILE);
				$d = ($d+1);
				$s=$scount+$d;
				@list = split(/\|/, $data[1]);
				if($list[1]) { 
					$mailto = "<a href=mailto:$list[1]>$list[0]</a>";}else {$mailto = $list[0];
				}  
				$old_date = substr($list[4],0,10);
				&getdate;
				$new_date = substr($date,0,10);
				if($old_date eq $new_date) {
					$subject = "<img src=$img_url/newgul.gif border=0>";} else{ $subject = "<img src=$img_url/gul.gif border=0>";
				}                
				print "<tr bgcolor=$cel_color><td><font color=$num_color face=arial size=-1>$num</font></td><td align=left><font face=arial size=-1><a href=$cgi_url?id=$FORM{'id'}&page=$page&action=view&number=$num&category=$FORM{'category'}&keyword=$FORM{'keyword'}>$subject $list[3]</a></font></td><td align=center><font face=arial size=-1>$mailto</font></td><td align=center><font face=arial size=-1 color=$date_color>$list[4]</font></td><td align=center><font face=arial size=-1 color=$read_color>$list[5]</font></td></tr>\n";
			}
			if($d >= $page_num) { $page= $FORM{'page'}; last;}
         }
	}
	print "</table></td></tr></table><br>";
	&pagemove;

	if($search_view eq "yes"){
		&find;
	}

	&foot;
}

sub find {
	print "<form method=post action=$cgi_url>\n";
	print "<table><tr><td><input type=hidden name=action value=search><input type=hidden name=id value=$FORM{'id'}>\n";
    print "<select name=category>\n";
    print "<option value=all> ü</option>\n";
    print "<option value=name> </option>\n";
    print "<option value=subject> </option>\n";
    print "<option value=comment> </option>\n";
    print "</select></td>\n";
 	print "<td><input type=text name=keyword size=15 style=\"background-color:#FFFFFF;height:21px;border:1 solid $head_color\"> &nbsp;<input type=submit value=\" \" style=\"background-color:$cel_color;border:1 solid $head_color;height:20\"></td>\n";
	print "</form></tr></table>\n";
}

sub erase {
	&head;
print <<START;
<H2>йȣ ԷϽÿ.</H2>
<table><tr><td><ul>
<li> <font face=arial color=red><b>$FORM{'subject'}</b></font> մϴ.
<li>ѹ   ٽ   ϴ.
<li>̱ 亯 ۱  ˴ϴ</ul></td></tr></table>
<form method=post action=$cgi_url>
<input type=hidden name=action value=eraseok>
<input type=hidden name=page value=$FORM{'page'}>
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=number value=$FORM{'number'}>
<table><tr><td>йȣ</td><td><input type=password name=passwd size=10 style="background-color:#ffffff;border:1 solid $head_color"></td><td><input type=submit value= style="background-color:$cel_color;border:1 solid $head_color;height:20"></td><td></form></td></tr></table>
START
	&foot;
}

sub eraseok {
	$pass = crypt($FORM{'passwd'},sp);
	open(FILE,"<$main_dir/$FORM{'number'}");
	@filea = <FILE>;
	@seper = split(/\|/,$filea[2]);
	close (FILE);
	unlink ("$main_dir/files/$seper[2]");
	chop($filea[0]);
	if(($filea[0] eq $pass) || ($admin eq $pass)) {
		$num = $FORM{'number'};
		if($filea[3] > 0) {
			&rurease;
		}
		unless($FORM{'number'} =~ /-/) {
			if(-e "$main_dir/$FORM{'number'}") {
				open(WF,"$main_dir/main.txt");
				$cou = <WF>;
				close(WF);
				$cou = $cou-1;
				&lock;
				open(WF,">$main_dir/main.txt");
				print WF "$cou";
				close(WF);
				&unlock;
			}
		}
		unlink("$main_dir/$FORM{'number'}");
		&display;
	}
	else {
		$err = pass;
		&error;
	}
}

sub admin_remove_ok {
	unlink("$main_dir/notice.txt");
	&display;
}

sub rurease {
	for($pp=1;$pp<=$filea[3];$pp++) {
		if(-e "$main_dir/$num-$pp") {
			open(FILE,"<$main_dir/$num-$pp");
            @fileb = <FILE>;
			@seper = split(/\|/,$fileb[2]);
            close (FILE);
			unlink("$main_dir/$num-$pp");
			unlink("$main_dir/files/$seper[2]");
			if($fileb[3] > 0) {
				for($pq=1;$pq<=$fileb[3];$pq++) {
					if(-e "$main_dir/$num-$pp-$pq") {
						 open(FILE,"<$main_dir/$num-$pp-$pq");
						 @filec = <FILE>;
						 @seper = split(/\|/,$filec[2]);
						 close (FILE);
					     unlink("$main_dir/$num-$pp-$pq");
						 unlink ("$main_dir/files/$seper[2]");
						 if($filec[3] > 0) {	
							for($pr=1;$pr<=$filec[3];$pr++) {
								if(-e "$main_dir/$num-$pp-$pq-$pr") {
									open(FILE,"<$main_dir/$num-$pp-$pq-$pr");
									@filed = <FILE>;
									@seper = split(/\|/,$filed[2]);
									close (FILE);
									unlink("$main_dir/$num-$pp-$pq-$pr");
									unlink("$main_dir/files/$seper[2]");
									if($filed[3] > 0) {
										for($ps=1;$ps<=$filed[3];$ps++) {
											if(-e "$main_dir/$num-$pp-$pq-$pr-$ps") {
												open(FILE,"<$main_dir/$num-$pp-$pq-$pr-$ps");
												@filee = <FILE>;
												@seper = split(/\|/,$filee[2]);
												close (FILE);
												unlink("$main_dir/$num-$pp-$pq-$pr-$ps");
												unlink("$main_dir/files/$seper[2]");
												if($filee[3] > 0) {
													for($pt=1;$pt<=$filee[3];$pt++) {
											            if(-e "$main_dir/$num-$pp-$pq-$pr-$ps-$pt") {
															open(FILE,"<$main_dir/$num-$pp-$pq-$pr-$ps-$pt");
															@filef = <FILE>;
															@seper = split(/\|/,$filef[2]);
															close (FILE);
															unlink("$main_dir/$num-$pp-$pq-$pr-$ps-$pt");
															unlink("$main_dir/files/$seper[2]");
															if($filef[3] > 0) {
																for($pu=1;$pu<=$filef[3];$pu++) {
																     if(-e "$main_dir/$num-$pp-$pq-$pr-$ps-$pt-$pu") {
																		open(FILE,"<$main_dir/$num-$pp-$pq-$pr-$ps-$pt-$pu");
															            @fileg = <FILE>;
																		@seper = split(/\|/,$fileg[2]);
																		close (FILE);
																		unlink("$main_dir/$num-$pp-$pq-$pr-$ps-$pt-$pu");
																		unlink("$main_dir/files/$seper[2]");
																		if($fileg[3] > 0) {
																			for($pv=1;$pv<=$fileg[3];$pv++) {
																	            if(-e "$main_dir/$num-$pp-$pq-$pr-$ps-$pt-$pu-$pv") {
																					open(FILE,"<$main_dir/$num-$pp-$pq-$pr-$ps-$pt-$pu-$pv");
																					@fileh = <FILE>;
																					@seper = split(/\|/,$fileh[2]);
																					close (FILE);
																					unlink("$main_dir/$num-$pp-$pq-$pr-$ps-$pt-$pu-$pv");
																					unlink("$main_dir/files/$seper[2]");
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									} 
								}
							}
						}
					}  
				}  
			}  
		} 
	}
}

sub pagemove{
	print "<div align=center><table><tr><td align=center>";

	$term = 10;
	$first = 1;
	$last = $term;
	while ($first <= $tot_pg) {
		if (($first <= $page) && ($page <= $last)) {
		$prevp = $first - 1;
			if ($prevp > 0) {
				if ($FORM{'action'} eq "search") {
					print "[<a href=$cgi_url?action=search&category=$FORM{'category'}&id=$FORM{'id'}&page=$prevp&keyword=$FORM{'keyword'} onmouseover=\"window.status='  ';return true\" onmouseout=\"window.status='';return true\"></a>].....";
				}
				else{
					print "[<a href=$cgi_url?id=$FORM{'id'}&page=$prevp onmouseover=\"window.status='  ';return true\" onmouseout=\"window.status='';return true\"></a>].....";
				}
			}
			else {
				print "[<font color=C0C0C0></font>].....";
			}
		if ($last <= $tot_pg) {
			for ($pa = $first; $pa <= $last; $pa++) {
				if ($pa == $page) {
					print "[<font color=red><b>$pa</b></font>] ";
				}
				else {
					if($FORM{'action'} eq "search") {
						print "[<a href=$cgi_url?action=search&category=$FORM{'category'}&id=$FORM{'id'}&page=$pa&keyword=$FORM{'keyword'} onmouseover=\"window.status='$pa  ̵';return true\" onmouseout=\"window.status='';return true\">$pa</a>] ";
					}
					else{
						print "[<a href=$cgi_url?id=$FORM{'id'}&page=$pa onmouseover=\"window.status='$pa  ̵';return true\" onmouseout=\"window.status='';return true\">$pa</a>] ";
					}
				}
			}
		}
		else {
			for ($pa = $first; $pa <= $tot_pg; $pa++) {
				if ($pa == $page) {
					print "[<font color=red><b>$pa</b></font>] ";
				}
				else {
					if($FORM{'action'} eq "search"){
						print "[<a href=$cgi_url?action=search&category=$FORM{'category'}&id=$FORM{'id'}&page=$pa&keyword=$FORM{'keyword'} onmouseover=\"window.status='$pa  ̵';return true\" onmouseout=\"window.status='';return true\">$pa</a>]  ";
					}
					else{
						print "[<a href=$cgi_url?id=$FORM{'id'}&page=$pa onmouseover=\"window.status='$pa  ̵';return true\" onmouseout=\"window.status='';return true\">$pa</a>]  ";
					}
				}
			}
		}
		$nextp = $last + 1;
		if ($nextp <= $tot_pg) {
			if($FORM{'action'} eq "search") {
				print ".....[<a href=$cgi_url?action=search&category=$FORM{'category'}&id=$FORM{'id'}&page=$nextp&keyword=$FORM{'keyword'} onmouseover=\"window.status='  ';return true\" onmouseout=\"window.status='';return true\"></a>]";
			}
			else{
				print ".....[<a href=$cgi_url?id=$FORM{'id'}&page=$nextp onmouseover=\"window.status='  ';return true\" onmouseout=\"window.status='';return true\"></a>]";
			}
		}
		else {
			print ".....[<font color=C0C0C0></font>]";
		}
	}
	$first = $first + $term;
	$last = $last + $term;
	}
	print "</td></tr></table></div>";
}

sub loginok {
			$pass = crypt($FORM{'passwd'},sp);

	if($admin eq $pass) {
		&head;
print <<START;
<p>&nbsp;
<p>&nbsp;
  Ͽϴ.<p>
ϴ ׸ Ͻð "LET'S GO!!!"ư ּ!
<form method=post action=$cgi_url> 
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=action value=admin_act>
<input type=hidden name=passwd value=$pass>
<select name=admin_select>
<option value="admin_conf" selected>ڷ ȯ漳
<option value="notice_form"> </select>
<input type=submit value=" LET'S GO!!! " style="background-color:$cel_color;border:1 solid $head_color;height:20">
</form>
<p>&nbsp;
<p>&nbsp;
START
		&foot;
	}
	else {
		$err = pass;
		&error;
	}
}

sub admin_conf {
	if($FORM{'passwd'} eq $admin){ 
		if($admin_only eq "yes"){
			$only_yes = "selected";
			$only_no = "";
		}
		else{
			$only_yes = "";
			$only_no = "selected";
		}
		if($smail eq "yes"){
			$smail_yes = "selected";
			$smail_no = "";
		}
		else{
			$smail_yes = "";
			$smail_no = "selected";
		}
		if($search_view eq "yes"){
			$search_yes = "selected";
			$search_no = "";
		}
		else{
			$search_yes = "";
			$search_no = "selected";
		}
		&head;
print <<START;
<form method=post action=$cgi_url>
<input type=hidden name=id value=$FORM{'id'}>
<input type=hidden name=action value=make_conf>
<input type=hidden name=passwd value=$FORM{'passwd'}>
<div align=center>
<table cellspacing=0 cellpadding=2 border=0 width=500 bgcolor=$head_color>
<tr><td align=center><b><font color=$cel_color>ȯ </font></b></td></tr>
<tr><td>
<table cellspacing=0 cellpadding=2 border=0 width=100%>
<tr bgcolor=#FFF3EF><td align=right>[йȣ : ĭ ״ νø  йȣ ]
<br>йȣ <input type=text name=pass size=10> ٽȮ <input type=text name=pass_eq size=10></td></tr>
<tr bgcolor=#FFF3EF><td align=right> ڸ ۾ 
<select name=admin_only>
<option value="yes" $only_yes>YES
<option value="no" $only_no>NO</select></td></tr>
<tr bgcolor=#FFF3EF><td align=right>ϴ ø ִ ִ 뷮(MB) <input type=text name=max_size size=10  maxlength=3 value="$max_size"></td></tr>
<tr bgcolor=#FDEDFF><td align=right> Ÿ   <input type=text name=page_num size=10  maxlength=3 value="$page_num"></td></tr>
<tr bgcolor=#FDEDFF><td align=right>Ÿ ִ   <input type=text name=max_data size=10  value="$max_data"></td></tr>
<tr bgcolor=#FDEDFF><td align=right>ڷ  <input type=text name=width size=10  maxlength=3 value="$width"></td></tr>
<tr bgcolor=#FCFFE7><td align=right> ̸ <input type=text name=admin_name size=10 value=$admin_name></td></tr>
<tr bgcolor=#FCFFE7><td align=right>Ȩ URL <input type=text name=home_url size=40 value=$home_url></td></tr>
<tr bgcolor=#FCFFE7><td align=right> ̸ ּ <input type=text name=admin_mail size=20 value="$admin_mail"></td></tr>
<tr bgcolor=#FCFFE7><td align=right>亯Ͻ Ϸ ˸ 
<select name=admin_select>
<option value="yes" $smail_yes>YES
<option value="no" $smail_no>NO</select></td></tr>
<tr bgcolor=#EDFFF0><td align=right> <input type=text name=bgcolor size=8 value=$bgcolor>
or  ̹ URL <input type=text name=background size=25 value=$background></td></tr>
<tr bgcolor=#EDFFF0><td align=right>  <input type=text name=ncel_color size=10 value=$ncel_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right> (ѻ) <input type=text name=head_color size=10 value=$head_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right> (ѻ) <input type=text name=cel_color size=10 value=$cel_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right>а ִ  ǥû <input type=text name=select_color size=10 value=$select_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right> ǥû <input type=text name=num_color size=10 value=$num_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right>¥ ǥû <input type=text name=date_color size=10 value=$date_color></td></tr>
<tr bgcolor=#EDFFF0><td align=right> ǥû <input type=text name=read_color size=10 value=$read_color></td></tr>
<tr bgcolor=#EFFBFF><td align=right>logo ̹ URL <input type=text name=logo_img size=45 value=$logo_img></td></tr>
<tr bgcolor=#EFFBFF><td align=right>ؽƮ ΰ <input type=text name=logo_txt size=45 value="$logo_txt"></td></tr>
<tr bgcolor=#EFFBFF><td align=right>˻â ̱
<select name=search_view>
<option value="yes" $search_yes>YES
<option value="no" $search_no>NO</select></td></tr>
</table>
</td></tr>
</table>
</div>
<br>
<input type=submit value=ϱ style="background-color:$cel_color;border:1 solid $head_color;height:20"> 
<input type=reset value=ٽþ style="background-color:$cel_color;border:1 solid $head_color;height:20">
</form>

START
		&foot;
	}
	else{
		$err=pass;
		&error;
	}
}

sub make_conf{
	if($FORM{'passwd'} eq $admin){ 
		if($FORM{'pass'} eq ""){
			$passwd = $admin;
		}
		elsif($FORM{'pass'} eq $FORM{'pass_eq'}){
		
			$pass = crypt($FORM{'pass'},sp);
			
			$passwd = $pass;	
		}
		else{
			$err=pass;
			&error;
		}
		
		open(SAVE,">$main_dir/conf.txt");
		print SAVE "$FORM{'max_size'}|$FORM{'page_num'}|$FORM{'admin_only'}|$FORM{'max_data'}|$passwd|$FORM{'admin_select'}|$FORM{'admin_mail'}|$FORM{'home_url'}|$FORM{'width'}|$FORM{'admin_name'}|$FORM{'ncel_color'}|$FORM{'head_color'}|$FORM{'cel_color'}|$FORM{'select_color'}|$FORM{'num_color'}|$FORM{'date_color'}|$FORM{'read_color'}|$FORM{'bgcolor'}|$FORM{'background'}|$FORM{'logo_img'}|$FORM{'logo_txt'}|$FORM{'search_view'}|\n";
		close(SAVE);

		open(CONF,"<$main_dir/conf.txt");
		@list = <CONF>;
		close(CONF);
		@env = split(/\|/,$list[0]);
        $max_size = $env[0];
		$page_num = $env[1];
		$admin_only = $env[2];
	    $max_data = $env[3];
		$admin = $env[4];
        $smail = $env[5];
	    $admin_mail = $env[6];
		$home_url = $env[7];
        $width = $env[8];
	    $admin_name = $env[9];
		$ncel_color = $env[10];
        $head_color = $env[11];
		$cel_color = $env[12];
		$select_color = $env[13];
        $num_color = $env[14];
	    $date_color = $env[15];
		$read_color = $env[16];
		$bgcolor = $env[17];
		$background = $env[18];
		$logo_img = $env[19];
		$logo_txt = $env[20];
		&display;
	}
	else{
		$err=pass;
		&error;
	}
}

sub view_notice{
	open(VFILE, "<$main_dir/notice.txt");
	@views = <VFILE>;
	close(VFILE);	
	@notice = split(/\|/,$views[0]);
	$html = $notice[0];
	$subject = $notice[1];
	$comments = $notice[2];
	$rdate=substr($notice[3],0,18);
	$plus_num = $notice[5]+1;
	open(NFI,">$main_dir/notice.txt");
	print NFI "$html|$subject|$comments|$notice[3]|$notice[4]|$plus_num|\n";
	close(NFI);
	
	if ($html ne "1") { 
        $comments =~ s/<br>/\r\n/g;
	    $comments =~ s/<p>/\r\n\r\n/g;
	    $comments =~ s/</&lt;/g;
        $comments =~ s/>/&gt;/g;
        $comments =~ s/"/&quot;/g;
        $comments =~ s/\|/&#124;/g;
	    $comments =~ s/&lt;hr&gt;/<hr>/g;
	}
	$comments =~ s/\r\n\r\n/<p>/g;
    $comments =~ s/\r\n/<br>/g;
    $comments =~ s/\|/&#124;/g;
	$comments =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+)/$url <img src=$img_url\/home.gif> <a href=\"$1$2\" target=\"_new\">$1$2<\/a>/g;
    $comments =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$img_url\/mail.gif> <a href=\"mailto:$1\">$1<\/a>/g;

	&head;
print <<START;
<p>
<div align=center>
<table border=0 cellpadding=2 cellspacing=0 width=$width>
    <tr>
	<td colspan=2>ۼ - <font color=$date_color>$rdate</font></td>
	</tr>
	<tr  bgcolor=$head_color>
        <td><b><font color=$cel_color> $subject</font></b></td>
		<td align=right><font color=$cel_color>Down [ <b>$plus_num</b> ]</font>
			<a href=$cgi_url?id=$FORM{'id'}&action=admin_modify><img src=$img_url/modify.gif border=0 alt="ϱ"></a>
			<a href=$cgi_url?id=$FORM{'id'}&action=admin_remove><img src=$img_url/remove.gif border=0 alt="ϱ"></a> &nbsp;</td>
    </tr>
    <tr  bgcolor=$head_color>
        <td colspan=2>
			<table border=0 cellpadding=3 cellspacing=0 width=100% bgcolor=$cel_color>
                <tr>
                    <td height=220 valign=top>$comments</td>
                </tr>
            </table></td>
    </tr>
</table></div>
<p>
[ <a href=$cgi_url?id=$FORM{'id'}>Ʈ ư</a> ]
START
	&foot;
}

sub lock {
    local($LockFile) = "$main_dir/lock.txt";
    local($EndTime) = time+45;
    
    while (-s $LockFile && time < $EndTime) {
    	sleep(1);
    }
    open(LOCK, ">$main_dir/$LockFile");
    print LOCK "lock";
    close(LOCK);
}

sub unlock {
    local($LockFile) = "$main_dir/lock.txt";
    
    open(LOCK, ">$main_dir/$LockFile");
    print LOCK "";
    close(LOCK);
}

sub sendmail {
		open (MAIL, "|$sendmail -t $addr");
		print MAIL "Reply-to: $admin_mail\n";
		print MAIL "From: $admin_name<$admin_mail>\n";
		print MAIL "Subject: 亯 ϵǾϴ.\n\n";
       	print MAIL "\n\n$FORM{'name'}Բ  ۿ 亯 Ͽϴ.\n";
       	print MAIL "Ʒ Ȩ 湮Ͻþ ȮϽñ ٶϴ.\n\n";
    	print MAIL "ߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡ\n";
    	print MAIL "\t This message form $home_url\n";
    	print MAIL "ߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡߡ\n\n";
		close (MAIL);
}

EOF